#include <stdio.h>
#include <stdlib.h>

/*  primos con 4|p-1 que dividen a x^4+2 para algn x,
para ellos x^4+2 factoriza del todo */


#define NPRIM 1000
unsigned int primo[NPRIM]={2,3};

int esprimo(int n){
	int i=0;
	if ( n==1) return 0;
	while( primo[i]*primo[i]<=n )
		if( (n % primo[i++])==0 ) return 0;
	return 1;	
}

void listaprimos(void){
	int i;
	for(i=2;i<NPRIM; ++i){
		primo[i]=primo[i-1]+2;
		while( !esprimo(primo[i]) ) primo[i]+=2;
	}
}


int quart(int n){
	int i,j;
	for(i=0;i<n;++i){
		j= (i*i)%n;
		j= (j*j)%n;
		if ( ((j+2) % n)==0 ){
			printf("n=%d div a %d^4+2\n",n,i);
			return 1;
		}
	}
	return 0;
}


int main(int argc, char *argv[]){
	int n;
	listaprimos();
	for(n=5;n<primo[NPRIM-1];n+=4){
		if( esprimo(n) ){
//if( ((n-1)%8)==0 ) printf("n=%d\n",n);
			quart(n);
		}
	}

}
